<template lang="pug">
.row
  .gt-sm.col-sm-4.col-md-3
    LeaderBoard

  .col-12.col-sm-12.col-md-9
    ModerationFilter(:terms="terms", useTarget="true", showLocked="true")
    FilterMessage(:terms="terms")
    .text-center(v-if="!filtered.length") {{ $t('no_tasks_match') }}
    q-infinite-scroll(
      scroll-target="body",
      @load="onLoad",
      :offset="250",
      ref="scroller"
    )
      template(v-slot:loading)
        .row.justify-center.q-my-md
          q-spinner-dots(color="primary", size="40px")
      LangItem(
        v-for="lang in filtered",
        :key="lang.id",
        :lang="lang",
        :user="user"
      )
        template(v-slot:score) {{ getScore(lang) }}
        template(v-slot:default)
          q-btn(
            v-if="isMine(lang)",
            flat,
            round,
            color="black",
            icon="lock_open",
            @click="unlock(lang)"
          )
            q-tooltip {{ $t('unlock') }}
          q-option-group.full-width.text-center.q-mt-lg(
            v-if="isMine(lang)",
            dense,
            :options="traffic",
            keep-color,
            type="radio",
            v-model="lang.multiplier"
          )

          q-btn(
            v-if="isMine(lang)",
            flat,
            round,
            color="positive",
            icon="check",
            @click="verified(lang)"
          )
            q-tooltip {{ $t('approve') }}

          q-btn(
            v-if="isMine(lang)",
            flat,
            round,
            color="negative",
            icon="not_interested",
            @click="notVerified(lang)"
          )
            q-tooltip {{ $t('reject') }}

          q-btn(
            flat,
            round,
            v-if="!isMine(lang) || isOthers(lang)",
            icon="lock",
            @click="lock(lang)"
          )
            q-tooltip(v-if="!isMine(lang) && !isOthers(lang)") {{ $t('lock_for_myself') }}
            q-tooltip(v-if="isMine(lang)") {{ $t('locked_for_me') }}
</template>

<script>
import LeaderBoard from "@/components/LeaderBoard";
import ModerationFilter from "@/components/ModerationFilter";
import FilterMessage from "@/components/FilterMessage";
import LangItem from "@/components/LangItem";
import { filter, last, findIndex } from "lodash";
import { db, FieldValue } from "@/db";
import { mapState } from "vuex";

export default {
  data: () => {
    return {
      terms: {
        showLocked: false,
      },
      langs: [],
      config: {},
      traffic: [
        {
          label: "",
          value: 10,
          color: "green",
        },
        {
          label: "",
          value: 7,
          color: "amber",
        },
        {
          label: "",
          value: 5,
          color: "red",
        },
      ],
    };
  },
  computed: {
    ...mapState({
      user: (state) => state.user,
    }),
    filtered() {
      return filter(this.langs, { status: "readyforverify" });
    },
  },
  watch: {
    terms: {
      deep: true,
      // immediate:true,
      async handler() {
        this.langs = [];
        this.$refs.scroller.reset();
        this.$refs.scroller.resume();
        this.$refs.scroller.trigger();
      },
    },
  },
  methods: {
    isMine(item) {
      return item.activeUser && item.activeUser == `users/${this.user.id}`;
    },
    isOthers(item) {
      return item.activeUser && item.activeUser != `users/${this.user.id}`;
    },
    async unlock(item) {
      // console.log("saving");
      Object.assign(item, {
        activeUser: null,
        markedActiveAt: null,
      });

      await db.collection("langs").doc(item.id).update({
        activeUser: null,
        markedActiveAt: null,
      });

      let index = findIndex(this.langs, { id: item.id });
      this.$set(this.langs, index, item);
    },
    async lock(item) {
      // console.log("saving");
      Object.assign(item, {
        activeUser: `users/${this.user.id}`,
        markedActiveAt: FieldValue.serverTimestamp(),
      });

      await db
        .collection("langs")
        .doc(item.id)
        .update({
          activeUser: `users/${this.user.id}`,
          markedActiveAt: FieldValue.serverTimestamp(),
        });

      let index = findIndex(this.langs, { id: item.id });
      this.$set(this.langs, index, item);
    },
    async verified(item) {
      try {
        if (!item.type) {
          if (
            typeof item.targetText == "undefined" ||
            (item.targetText.length == 0 && typeof item.type == "undefined")
          )
            throw new Error(this.$t("no_text_entered"));
        }

        Object.assign(item, {
          status: "finalised",
          score: this.getScore(item),
          verifiedBy: `users/${this.user.id}`,
          activeUser: null,
          multiplier: item.multiplier,
          verifiedAt: FieldValue.serverTimestamp(),
        });
        if (!item.type) Object.assign(item, { targetText: item.targetText });

        await db.collection("langs").doc(item.id).update(item);
      } catch (e) {
        this.showError(e);
      }
    },
    async notVerified(item) {
      this.$q
        .dialog({
          title: this.$t("reject_verify"),
          message: this.$t("reject_reason"),
          prompt: {
            model: "",
            type: "text", // Optional
          },
          cancel: true,
          persistent: true,
        })
        .onOk(async (data) => {
          try {
            Object.assign(item, {
              status: "readyformanualtranslate",
              notes: data,
              activeUser: null,
            });
            // console.log(item.id);
            await db.collection("langs").doc(item.id).update(item);
          } catch (e) {
            this.showError(e);
          }
        });
    },
    getScore(lang) {
      if (
        lang.type === "hd_video" ||
        lang.type === "static_video" ||
        lang.type === "square_video"
      )
        return this.config.score_map["verification_hd_video"];
      else if (lang.type === "static_article")
        return this.config.score_map["verification_static_article"];
      else if (lang.type === "static_image")
        return this.config.score_map["verification_static_image"];
      else return this.config.score_map["verification"];
    },
    async onLoad(index, done) {
      // console.log("loading more", index);
      await this.getLangs(done);
    },
    async getLangs(done) {
      try {
        // console.log('getting subs')
        // this.loading = true;
        let ref = db
          .collection("langs")
          .where("status", "==", "readyforverify");

        if (this.terms.lang) {
          ref = ref.where("srcLang", "==", this.terms.lang);
        }

        if (this.terms.targetLang) {
          ref = ref.where("targetLang", "==", this.terms.targetLang);
        }

        if (this.terms.showLocked) {
          ref = ref.where("activeUser", "==", `users/${this.user.id}`);
        }

        ref = ref.orderBy("createdAt", "asc");

        if (this.langs.length > 0) {
          let lastl = last(this.langs);
          let lastref = lastl._doc;
          ref = ref.startAfter(lastref);
        }

        ref = ref.limit(5);

        await this.$bind("tmpsubs", ref, {
          maxRefDepth: 1,
        });

        this.tmpsubs.forEach((doc) => {
          doc.multiplier = 10;
          this.langs.push(doc);
        });
        let length = this.tmpsubs.length;

        // Prevent from receiving updates automatically
        this.$unbind("tmpsubs", true);

        done(length == 0);
      } catch (e) {
        console.log(e);
        // this.loading = false;
        this.showError(e);
      }
    },
  },
  components: {
    LeaderBoard,
    ModerationFilter,
    FilterMessage,
    LangItem,
  },
  firestore: {
    config: db.collection("config").doc("meta"),
  },
};
</script>

<style>
.list-enter-active,
.list-leave-active,
.list-move {
  transition: 500ms cubic-bezier(0.59, 0.12, 0.34, 0.95);
  transition-property: opacity, transform;
}

.list-enter {
  opacity: 0;
  transform: translateX(50px) scaleY(0.5);
}

.list-enter-to {
  opacity: 1;
  transform: translateX(0) scaleY(1);
}

.list-leave-active {
  position: absolute;
}

.list-leave-to {
  opacity: 0;
  transform: scaleY(0);
  transform-origin: center top;
}
</style>
